local version = "1.1 beta"
LootWhatIWant = { }
LootWhatIWant.enabled = true
LootWhatIWant.blacklist = { }
LootWhatIWant.blacklistcount = { }
LootWhatIWant.activeInGroup = false
LootWhatIWant.deleteItems = false
LootWhatIWant.kzloot = false
LootWhatIWant.mcloot = false
LootWhatIWant.zgloot = false
LootWhatIWant.aq20 = false
LootWhatIWant.aq40 = false
LootWhatIWant.deleteallgrays = false -- does what you think, use at your own peril.
LootWhatIWant.deleteasomegrays = 0
LootWhatIWant.mouseover = false
LootWhatIWant.blacklist_GUI_linenumber = 0
LootWhatIWant.Inventorylist_GUI_linenumber = 0
LootWhatIWant.MobList_GUI_mobname = nil
local LootBlacklist = 0
local LootedItem = ""
local blacklisted = false
local LootWhatIWant_Frame = CreateFrame("Frame", "LootWhatIWantFrame")

function LWIW_InGroup()
	if (GetNumRaidMembers() > 0) or (GetNumPartyMembers() > 0) then
		if (LootWhatIWant.activeInGroup) then
			return true
		elseif (GetRealZoneText() == "Zul'Gurub") and (LootWhatIWant.zgloot) then
			return true
		elseif (GetRealZoneText() == "Molten Core") and (LootWhatIWant.mcloot) then
			return true
		elseif(GetRealZoneText() == "Karazhan") and (LootWhatIWant.kzloot) then
			return true
		elseif (GetRealZoneText() == "Ruins of Ahn'Qiraj") and (LootWhatIWant.aq20) then
			return true
		elseif (GetRealZoneText() == "Temple of Ahn'Qiraj") and (LootWhatIWant.aq40) then
			return true
		else
			return false
		end
	else
		return true
	end
end


function LootWhatIWant_LOOT_OPENED()
	if not (LootWhatIWant.enabled) then return end
	if (LootWhatIWant.deleteallgrays == nil) then
		LootWhatIWant.deleteallgrays = false
	end
	if (event == "LOOT_OPENED") then
		blacklisted = false
		LootBlacklist = 0
		local auloot = GetCVar("autoLootDefault")
		local mobname
		if (GetUnitName("target") == nil) then
			mobname = nil
		else
			if (UnitIsDead("target")) then
				mobname = string.lower(GetUnitName("target"))
			else
				mobname = nil
			end
		end
		if (auloot == "1") then
			if (LootWhatIWant.enabled == true) then
				print("Auto loot is on, LootWhatIWant can not work with that.  Please disable LWIW or AutoLoot (in your interface settings).")
				return
			end
		else
			if (GetNumLootItems() > 0) then
				for i = 1, GetNumLootItems() do
					curSlot = i
					
					local lootIcon, lootName, lootQuantity, rarity, locked = GetLootSlotInfo(i)
					local item
					local itemstring
					if (rarity == 0) then
						if (LootWhatIWant.deleteallgrays) then
							blacklisted = true
						elseif(LootWhatIWant.deletesomegrays > 0) then
							blacklisted = true
						end
					end
					if not (LootWhatIWant.blacklist[item]) then
						if (locked ~= 1) then
							LootSlot(i)
							if LWIW_InGroup() then
								StaticPopup_Hide("LOOT_BIND")
								ConfirmLootSlot(i)
							end
						end
					else
						if (LootWhatIWant.deleteItems) then
							if (locked ~= 1) then
								blacklisted = true
								LootBlacklist = LootBlacklist + 1
								LootSlot(i)
								if LWIW_InGroup() then
									StaticPopup_Hide("LOOT_BIND")
									ConfirmLootSlot(i)
								end
								
							end
						else
							--print("here")
							
							--wasn't sure if i wanted to put a print here to let people know it was ignored or not.
						end
					end
					
				end
			else
				CloseLoot()
			end
		end
	elseif (event == "BAG_UPDATE") then
		if (blacklisted) then
			LWIW_Delete()
			blacklisted = false
		end
	end
end

function LWIW_Delete()
	for bag = 0, NUM_BAG_SLOTS do
		for slot=1, GetContainerNumSlots(bag) do
			local texture, count, locked, quality, readable, lootable, link = GetContainerItemInfo(bag, slot)
			if (link ~= nil) then
				local iitem = string.match(link, "item:(%d+)")
				if (iitem ~= nil) then
					local itemName, iitemLink, iitemRarity, iitemLevel, iitemMinLevel, iitemType, iitemSubType, iitemStackCount, iitemEquipLoc, iitemTexture, iitemSellPrice = GetItemInfo(iitem)
					print("here")
					--print(iitemLink.." - "..iitemStackCount.." - "..iitemSellPrice)
					if (iitemRarity == 0) and (LootWhatIWant.deleteallgrays) then
						PickupContainerItem(bag, slot)
						DeleteCursorItem()
						print("Deleted: "..link)
					end
					if (iitemRarity == 0) and ((iitemSellPrice * iitemStackCount) < LootWhatIWant.deletesomegrays) then
						PickupContainerItem(bag, slot)
						DeleteCursorItem()
						print("Deleted: "..link)
					end
					if (LootWhatIWant.blacklist[iitem]) then
						PickupContainerItem(bag, slot)
						DeleteCursorItem()
						print("Deleted: "..link)
						
					end
				end
				
			end
		end
	end
end

function LWIW_Add(itemnum, name)
	if (LootWhatIWant.blacklist[itemnum] ~= nil) then
		print(name.." is already in your blacklist.")
	else
		print(name.." has been added to your blacklist.")
		LootWhatIWant.blacklist[itemnum] = name
		if (LootWhatIWant.blacklistcount == nil) then
			LootWhatIWant.blacklistcount = {}
			LootWhatIWant.blacklistcount[1] = itemnum
		else
			LootWhatIWant.blacklistcount[(#LootWhatIWant.blacklistcount + 1)] = itemnum
		end
		LWIW_BlackListSB_Update()
	end
end

function LWIW_Remove(itemnum, name)
	if (LootWhatIWant.blacklist[itemnum] ==  nil) then
		print(name.." is not in your blacklist.")
	else
		print(name.." has been removed from your blacklist.")
		LootWhatIWant.blacklist[itemnum] = nil
		for i = 1, #LootWhatIWant.blacklistcount do
			if (LootWhatIWant.blacklistcount[i] == itemnum) then
				table.remove(LootWhatIWant.blacklistcount, i)
				break
			end
		end
		LWIW_BlackListSB_Update()
	end
end



SLASH_LOOTWHATIWANT1 = "/lwiw"
SlashCmdList["LOOTWHATIWANT"] = function(msg)
	if( msg ) then
		--local command2 = string.lower(msg);
		local command, rest2 = msg:match("^(%S*)%s*(.-)$")
		local rest
		local itemnum = nil
		command = string.lower(command)
		if (command == "deletesomegrays") then
			if (rest2 == "") then
				print("You did not specify a floor amount to delete greys, if you want to delete all greys, please use /lwiw deleteallgrays, otherwise include a number after the deletesomegrays command.")
			else
				if (tonumber(rest2) == nil) then
					print("Did not enter a number after the deletesomegrays command.  If you want to delete all greys, please use /lwiw deleteallgrays, otherwise include a number after the deletesomegrays command.")
				else
					LootWhatIWant.deletesomegrays = tonumber(rest2)   -- try to convert it to a number
					print("LWIW will now delete grays under value of: "..GetCoinTextureString(rest2))
				end
			end
			return
		end

		if (rest2 ~= "") then
			itemnum = string.match(rest2, "item:(%d+)")
			if(itemnum == nil) then
				print("Not a valid item link after add/remove command.")
				return
			end
		end
		
		if (command == "add") then
			LWIW_Add(itemnum, rest2)
		elseif (command == "remove") then
			LWIW_Remove(itemnum, rest2)
		elseif(command == "disable") then
			print("LootWhatIWant disabled")
			LootWhatIWant.enabled = false
		elseif(command == "enable") then
			print("LootWhatIWant enabled")
			LootWhatIWant.enabled = true
		elseif(command == "delete") then
			if (LootWhatIWant.deleteItems) then
				print("Will NOT loot items but leave them on the corpse.")
				LootWhatIWant.deleteItems = false
			else
				LootWhatIWant.deleteItems = true
				print("Will auto delete items from your blacklist after looting.")
			end
		elseif(command == "zg") then
			if (LootWhatIWant.zgloot) then
				LootWhatIWant.zgloot = false
				print("Will NOT auto loot in ZG.")
			else
				LootWhatIWant.zgloot = true
				print("Will AUTO loot in ZG.")
			end
		elseif(command == "kz") then
			if (LootWhatIWant.kzloot) then
				LootWhatIWant.kzloot = false
				print("Will NOT auto loot in Kara.")
			else
				LootWhatIWant.kzloot = true
				print("Will AUTO loot in Kara.")
			end
		elseif(command == "mc") then
			if (LootWhatIWant.mcloot) then
				LootWhatIWant.mcloot = false
				print("Will NOT auto loot in MC.")
			else
				LootWhatIWant.mcloot = true
				print("Will AUTO loot in MC")
			end
		elseif(command == "aq20") then
			if (LootWhatIWant.aq20) then
				LootWhatIWant.aq20 = false
				print("Will NOT auto loot in AQ20.")
			else
				LootWhatIWant.aq20 = true
				print("Will AUTO loot in AQ20")
			end
		elseif(command == "aq40") then
			if (LootWhatIWant.aq40) then
				LootWhatIWant.aq40 = false
				print("Will NOT auto loot in AQ40.")
			else
				LootWhatIWant.aq40 = true
				print("Will AUTO loot in AQ40")
			end
		elseif(command == "deleteallgrays") then
			if (LootWhatIWant.deleteallgrays) then
				LootWhatIWant.deleteallgrays = false
				print("Will NO longer delete all grays looted.")
			else
				LootWhatIWant.deleteallgrays = true
				print("Will DELETE ALL gray items looted.")
			end
		elseif(command == "gui") then
			 InterfaceOptionsFrame_OpenToCategory(LootWhatIWant_panel)
		else
			print("LootWhatIWant Mod")
			print("usage /lwiw -- prints help")
			print("/lwiw add [item] -- add an item to the blacklist to not loot, must be in proper item format (ie shift click after the word add).")
			print("/lwiw remove [item] -- remove an item from the blacklist, must be in proper item format (ie shift click after the word add).")
			print("/lwiw enable -- enable this addon")
			print("/lwiw disable -- disable this addon")
			print("/lwiw gui -- display gui")
			print("/lwiw zg or mc or kz or aq20 or aq40 -- enable/disable auto loot in ZG/MC/KZ/AQ20/AQ40 respectivily.")
			print("/lwiw deleteallgrays -- delete all grays looted, no matter if in blacklist or not.")
			print("/lwiw deletesomegrays # -- delete grays that are less then the # you enter in value.  (ie if an item stacks 20 and each is worth 15s, even if you have 1 in your bag, LWIW values it as 3g instead of 15s).")
			print("/lwiw delete -- toogles looting then deleting items in your blacklist.  Disabled by default.  Have tested as much as I can, Use this at YOUR own risk.")
			print("this will not work while your in a group/raid.  If you want it to look in the lua file for activeInGroup and change to true.  Use at your own risk, not responsible for -dkp or whatever.")
		end
	end
end
LootWhatIWant_Frame:RegisterEvent("BAG_UPDATE")
--LootWhatIWant:RegisterEvent("LOOT_SLOT_CLEARED")
LootWhatIWant_Frame:RegisterEvent("LOOT_OPENED")

LootWhatIWant_Frame:SetScript("OnEvent", LootWhatIWant_LOOT_OPENED)